/*
* Copyright (C) 2003-2006 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// MailFoldersSettings.cpp : implementation file
//

#include "stdafx.h"
#include "ui.h"
#include "MailFoldersSettings.h"
#include "RegistrySettings.h"
#include "pim/Maincpp.h"


// CMailFoldersSettings dialog

IMPLEMENT_DYNAMIC(CMailFoldersSettings, CDialog)

CMailFoldersSettings::CMailFoldersSettings(CWnd* pParent /*=NULL*/)
	: CDialog(CMailFoldersSettings::IDD, pParent)
{

}

CMailFoldersSettings::~CMailFoldersSettings()
{
}

void CMailFoldersSettings::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SETTMAIL_FOLDCHECK_DRAFT, checkDraft);
	DDX_Control(pDX, IDC_SETTMAIL_FOLDCHECK_TRASH, checkTrash);
	DDX_Control(pDX, IDC_SETTMAIL_FOLDCHECK_SENT, checkSent);
}


BEGIN_MESSAGE_MAP(CMailFoldersSettings, CDialog)	
END_MESSAGE_MAP()


BOOL CMailFoldersSettings::OnInitDialog()
{
	CString s1;
	s1.LoadString(IDS_MAIL_FOLDERS); SetWindowText(s1); 

	CDialog::OnInitDialog();

    #if defined(WIN32_PLATFORM_WFSP)
        if (!dlgCommandBar3.Create(this) ||
            !dlgCommandBar3.InsertMenuBar(IDR_MENUBAR_OKCANCEL))
        {
            //AfxMessageBox(_T("Failed to create CommandBar\n"));
            return FALSE;      // failed to create
        } 
        dlgCommandBar3.Show(true);
    #else
        ZeroMemory(&dlgCommandBar, sizeof(SHMENUBARINFO));
        dlgCommandBar.cbSize = sizeof(SHMENUBARINFO); 
        dlgCommandBar.hwndParent = this->GetSafeHwnd(); 
        dlgCommandBar.dwFlags = SHCMBF_HMENU;
        dlgCommandBar.nToolBarId = IDM_OKCANCEL; 
        dlgCommandBar.hInstRes = ::AfxGetInstanceHandle();
        dlgCommandBar.nBmpId = 0; 
        dlgCommandBar.cBmpImages = 0; 
        if(!SHCreateMenuBar(&dlgCommandBar)){
            AfxMessageBox(_T("Cannot create command bar!")); 
            return FALSE;
        }
    #endif
	
 //-- load string resources
 s1.LoadString(IDS_FOLDERS_DRAFT); 	SetDlgItemText(IDC_SETTMAIL_FOLDCHECK_DRAFT, s1);
 s1.LoadString(IDS_FOLDERS_TRASH); 	SetDlgItemText(IDC_SETTMAIL_FOLDCHECK_TRASH, s1);
 s1.LoadString(IDS_FOLDERS_SENT); 	SetDlgItemText(IDC_SETTMAIL_FOLDCHECK_SENT, s1);
 s1.LoadString(IDS_FOLDERS_2SYNC);	SetDlgItemText(IDC_SETTMAIL_STATIC_SYNCFOLDERS, s1);

 //-- read values from Registry
 SyncRegSettings regsettings("mail");
 CString s3; 
	
 if (regsettings.cs.mailssconfig.getDraft() == 1)
    checkDraft.SetCheck(BST_CHECKED);
 if (regsettings.cs.mailssconfig.getTrash() == 1)
    checkTrash.SetCheck(BST_CHECKED);
 if (regsettings.cs.mailssconfig.getSent() == 1)
    checkSent.SetCheck(BST_CHECKED);

  checkSent.SetFocus();
  return FALSE;
}

void CMailFoldersSettings::OnOK()
{
  SyncRegSettings regsettings("mail", false);
  CString s3; 

  if(checkDraft.GetCheck() == BST_CHECKED)
      regsettings.cs.mailssconfig.setDraft(1);
  else		
      regsettings.cs.mailssconfig.setDraft(0);
  if(checkTrash.GetCheck() == BST_CHECKED)
       regsettings.cs.mailssconfig.setTrash(1);
  else
       regsettings.cs.mailssconfig.setTrash(0);
	
  if(checkSent.GetCheck() == BST_CHECKED)
   regsettings.cs.mailssconfig.setSent(1);		
  else
   regsettings.cs.mailssconfig.setSent(0);

  if(! checkStartSync()){
      regsettings.writeToRegistry("mail", false);
  }
  
  CDialog::OnOK();
}