/*
* Copyright (C) 2003-2006 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// SyncSettings.cpp : implementation file
//

#include "stdafx.h"
#include "SyncSettings.h"

#include "ContactSettings.h"
#include "CalendarSettings.h"
#include "TaskSettings.h"
#include "MailSettings.h"
#include "BriefcaseSettings.h"
#include "RegistrySettings.h"

#if defined(WIN32_PLATFORM_PSPC)
    #include "NotesSettings.h"
#endif

#include "aygshell.h"
#include "pim/maincpp.h"
#include "pim/account.h"

// CSyncSettings dialog

#define ADVANCED_CONTACTS 1
#define ADVANCED_CALENDAR 2
#define ADVANCED_TASKS 4
#define ADVANCED_MAIL 8
#define ADVANCED_BRIEFCASE 16
#define ADVANCED_NOTES 32

IMPLEMENT_DYNAMIC(CSyncSettings, CDialog)
char minutes[8][5] = {"5","10","15","30","60","120","240","1440"};

int getPollingPosition(CString value) {
    if (value.CompareNoCase(CString("5")) == 0)    return 0;
    if (value.CompareNoCase(CString("10"))== 0)   return 1;
    if (value.CompareNoCase(CString("15"))== 0)   return 2;
    if (value.CompareNoCase(CString("30"))== 0)   return 3;
    if (value.CompareNoCase(CString("60"))== 0)   return 4;
    if (value.CompareNoCase(CString("120"))== 0)  return 5;
    if (value.CompareNoCase(CString("240"))== 0)  return 6;
    if (value.CompareNoCase(CString("1440"))== 0) return 7;
    return 3; //default
}


CSyncSettings::CSyncSettings(CWnd* pParent /*=NULL*/)
	: CDialog(CSyncSettings::IDD, pParent)
{
}

CSyncSettings::~CSyncSettings()
{
}

void CSyncSettings::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_SYNC_CONTACTS, checkContacts);
    DDX_Control(pDX, IDC_SYNC_CALENDAR, checkCalendar);
    DDX_Control(pDX, IDC_SYNC_TASKS, checkTasks);
    DDX_Control(pDX, IDC_SYNC_MAIL, checkMail);
    DDX_Control(pDX, IDC_SYNC_BRIEFCASE, checkBriefcase);
    DDX_Control(pDX, IDC_ENCRYPTION, checkEncryption);
    DDX_Control(pDX, IDC_SCHEDULER_MINUTES, lstPolling);
    #if defined(WIN32_PLATFORM_PSPC) 
        DDX_Control(pDX, IDC_SYNC_NOTES, checkNotes);
        DDX_Control(pDX, IDC_SYNC_BUTTON_NOTES, butNotes);
        DDX_Control(pDX, IDC_SYNC_BUTTON_MAIL, butMail);
        DDX_Control(pDX, IDC_SYNC_BUTTON_CALENDAR, butCalendar);
        DDX_Control(pDX, IDC_SYNC_BUTTON_CONTACTS, butContacts);
        DDX_Control(pDX, IDC_SYNC_BUTTON_TASKS, butTasks);
        DDX_Control(pDX, IDC_SYNC_BUTTON_BRIEFCASE, butBriefcase);
    #endif

    #if defined(WIN32_PLATFORM_WFSP)
        DDX_Control(pDX, IDC_SCHEDULER_SPIN, spinPolling);
    #endif
    DDX_Control(pDX, IDC_SYNC_POLLING, checkPolling);
}


BEGIN_MESSAGE_MAP(CSyncSettings, CDialog)
    #if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
        ON_WM_SIZE()
    #endif
    ON_BN_SETFOCUS(IDC_SYNC_CONTACTS, &CSyncSettings::OnSetfocusSyncContacts)
    ON_BN_CLICKED(IDC_SYNC_CONTACTS, &CSyncSettings::OnBnClickedSyncContacts)
    ON_BN_SETFOCUS(IDC_SYNC_CALENDAR, &CSyncSettings::OnBnSetfocusSyncCalendar)
    ON_BN_SETFOCUS(IDC_SYNC_TASKS, &CSyncSettings::OnBnSetfocusSyncTasks)
    ON_BN_SETFOCUS(IDC_SYNC_MAIL, &CSyncSettings::OnBnSetfocusSyncMail)
    ON_BN_SETFOCUS(IDC_SYNC_BRIEFCASE, &CSyncSettings::OnBnSetfocusSyncBriefcase)
    ON_BN_CLICKED(IDC_SYNC_CALENDAR, &CSyncSettings::OnBnClickedSyncCalendar)
    ON_BN_CLICKED(IDC_SYNC_TASKS, &CSyncSettings::OnBnClickedSyncTasks)
    ON_BN_CLICKED(IDC_SYNC_MAIL, &CSyncSettings::OnBnClickedSyncMail)
    ON_BN_CLICKED(IDC_SYNC_BRIEFCASE, &CSyncSettings::OnBnClickedSyncBriefcase)
    ON_COMMAND(IDADVANCED, &CSyncSettings::showAdvanced)
    ON_BN_CLICKED(IDC_SYNC_POLLING, &CSyncSettings::OnBnClickedSyncPolling)
    ON_BN_SETFOCUS(IDC_SYNC_POLLING, &CSyncSettings::OnBnSetfocusSyncPolling)
    ON_LBN_SETFOCUS(IDC_SCHEDULER_MINUTES, &CSyncSettings::OnLbnSetfocusSchedulerMinutes)
    ON_BN_SETFOCUS(IDC_ENCRYPTION, &CSyncSettings::OnBnSetfocusEncryption)
    #if defined(WIN32_PLATFORM_PSPC) 
        ON_BN_CLICKED(IDC_SYNC_BUTTON_MAIL, &CSyncSettings::OnClickedSyncButtonMail)
        ON_BN_CLICKED(IDC_SYNC_BUTTON_CALENDAR, &CSyncSettings::OnClickedSyncButtonCalendar)
        ON_BN_CLICKED(IDC_SYNC_BUTTON_CONTACTS, &CSyncSettings::OnClickedSyncButtonContacts)
        ON_BN_CLICKED(IDC_SYNC_BUTTON_TASKS, &CSyncSettings::OnClickedSyncButtonTasks)
        ON_BN_CLICKED(IDC_SYNC_BUTTON_BRIEFCASE, &CSyncSettings::OnClickedSyncButtonBriefcase)
        ON_BN_CLICKED(IDC_SYNC_NOTES, &CSyncSettings::OnBnClickedSyncNotes)
        ON_BN_CLICKED(IDC_SYNC_BUTTON_NOTES, &CSyncSettings::OnClickedSyncButtonNotes)
    #endif
END_MESSAGE_MAP()


// CSyncSettings message handlers
BOOL CSyncSettings::OnInitDialog()
{
    CString s1;
    s1.LoadString(IDS_SYNC_SETTINGS);
    SetWindowText(s1);
    CDialog::OnInitDialog();

    #if defined(WIN32_PLATFORM_PSPC) 
        butMail.ShowWindow(TRUE);
        butCalendar.ShowWindow(TRUE);
        butContacts.ShowWindow(TRUE);
        butTasks.ShowWindow(TRUE);
        butBriefcase.ShowWindow(TRUE);
    #endif

   #ifdef WIN32_PLATFORM_WFSP
    if ( (!dlgCommandBarAdvanced.Create(this)) ||
         (!dlgCommandBarAdvanced.InsertMenuBar(IDR_MENUBAR_SAVEADVANCED)) )
    {
        AfxMessageBox(_T("cannot create menubar"));
        return FALSE;      // failed to create
    } 

    dlgCommandBarAdvanced.Show(true);
    spinPolling.SetRange(7,0); spinPolling.SetBuddy(&lstPolling);
  #else
    ZeroMemory(&dlgCommandBar, sizeof(SHMENUBARINFO));
    dlgCommandBar.cbSize = sizeof(SHMENUBARINFO); 
    dlgCommandBar.hwndParent = this->GetSafeHwnd(); 
    dlgCommandBar.dwFlags = SHCMBF_HMENU;
    #if (_WIN32_WCE < 0x500)
        dlgCommandBar.nToolBarId = IDM_OKCANCEL; 
    #else
        dlgCommandBar.nToolBarId = IDM_SAVEADVANCED; 
    #endif
    dlgCommandBar.hInstRes = ::AfxGetInstanceHandle();
    dlgCommandBar.nBmpId = 0; 
    dlgCommandBar.cBmpImages = 0; 
    if(!SHCreateMenuBar(&dlgCommandBar)){
        AfxMessageBox(_T("Cannot create command bar!")); 
        return FALSE;
    }
  #endif

    lstPolling.ResetContent();
    //-- add strings to polling list
    s1.LoadString(IDS_POLLING5); lstPolling.AddString(s1);
    s1.LoadString(IDS_POLLING10); lstPolling.AddString(s1);
    s1.LoadString(IDS_POLLING15); lstPolling.AddString(s1);
    s1.LoadString(IDS_POLLING30); lstPolling.AddString(s1);
    s1.LoadString(IDS_POLLING1H); lstPolling.AddString(s1);
    s1.LoadString(IDS_POLLING2H); lstPolling.AddString(s1);
    s1.LoadString(IDS_POLLING4H); lstPolling.AddString(s1);
    s1.LoadString(IDS_POLLING1D); lstPolling.AddString(s1);
    
    //-- read encryption value from registry
    CommunicationRegSettings reg;
    reg.readFromRegistry();

    SyncRegSettings regsettings("all");
    if( strcmp(regsettings.cs.getConfigSourcesParameter("contact","sync"), "none"))
        checkContacts.SetCheck(BST_CHECKED);
    else
    {
        checkContacts.SetCheck(BST_UNCHECKED);
        #if defined(WIN32_PLATFORM_PSPC) 
            butContacts.EnableWindow(FALSE);
        #endif
    }
        
    if(strcmp(regsettings.cs.getConfigSourcesParameter("calendar","sync"), "none"))
        checkCalendar.SetCheck(BST_CHECKED);
    else
    {
        checkCalendar.SetCheck(BST_UNCHECKED);
        #if defined(WIN32_PLATFORM_PSPC) 
            butCalendar.EnableWindow(FALSE);    
        #endif
    }
    
    if (!reg.cs.getIsPortal()) {
        checkTasks.EnableWindow(TRUE);
        if( strcmp(regsettings.cs.getConfigSourcesParameter("task","sync"), "none"))
            checkTasks.SetCheck(BST_CHECKED);
        else
        {
            checkTasks.SetCheck(BST_UNCHECKED);
            #if defined(WIN32_PLATFORM_PSPC) 
                butTasks.EnableWindow(FALSE);
            #endif
        }
    }
    else {
        checkTasks.EnableWindow(FALSE);
        checkTasks.SetCheck(BST_UNCHECKED);
    }
    if (doesFunambolAccountExist()) {
        checkMail.EnableWindow(TRUE);
        if( strcmp(regsettings.cs.getConfigSourcesParameter("mail","sync"), "none"))
            checkMail.SetCheck(BST_CHECKED);
        else{
                checkMail.SetCheck(BST_UNCHECKED);
                #if defined(WIN32_PLATFORM_PSPC) 
                    butMail.EnableWindow(FALSE);
                #endif
            }
    } else {
        checkMail.EnableWindow(FALSE);
    }

    if( strcmp(regsettings.cs.getConfigSourcesParameter("mail","sync"), "none"))
        checkMail.SetCheck(BST_CHECKED);
    else
    {
        checkMail.SetCheck(BST_UNCHECKED);
        #if defined(WIN32_PLATFORM_PSPC) 
            butMail.EnableWindow(FALSE);
        #endif
    }
    
    if (!reg.cs.getIsPortal()) {
        checkBriefcase.EnableWindow(TRUE);
        if( strcmp(regsettings.cs.getConfigSourcesParameter("briefcase","sync"), "none"))
            checkBriefcase.SetCheck(BST_CHECKED);
        else
        {
            checkBriefcase.SetCheck(BST_UNCHECKED);
            #if defined(WIN32_PLATFORM_PSPC) 
                butBriefcase.EnableWindow(FALSE);
            #endif
        }
    } else {
        checkBriefcase.EnableWindow(FALSE);
        checkBriefcase.SetCheck(BST_UNCHECKED);
    }
    
  #if defined(WIN32_PLATFORM_PSPC)
    if (!reg.cs.getIsPortal()) {
        checkNotes.EnableWindow(TRUE);
        if( strcmp(regsettings.cs.getConfigSourcesParameter("note","sync"), "none"))
            checkNotes.SetCheck(BST_CHECKED);
        else
        {
            checkNotes.SetCheck(BST_UNCHECKED);
            butNotes.EnableWindow(FALSE);
        }
    }  else {
        checkNotes.EnableWindow(FALSE);
        checkNotes.SetCheck(BST_UNCHECKED);
    }
  #endif
    
    
    //
    // Encryption is a property of every source. At the moment every source is
    // is encrypted or not at the same time. So the check for the encryption is made
    // only on a source that is contact
    //
    
    SyncRegSettings regcontacts("contact");
    const char* encr = regcontacts.cs.ssconfig.getEncryption();
    bool enc = false;
    if (strcmp(encr, "des") == 0)
        enc = true;    

    if(enc)
        checkEncryption.SetCheck(BST_CHECKED);
    else
        checkEncryption.SetCheck(BST_UNCHECKED);

    //-- check if push email is enabled
    pushEnabled +="";
    if( (reg.cs.getSms() == "1")  ||
        (reg.cs.getSms() == "2")  ||
        (reg.cs.getPush() == "1")  ||
        (reg.cs.getPush() == "2")  )
    {
        CString s3;
        s3.LoadString(IDS_PUSH_ENABLED);
        SetDlgItemText(IDC_SYNC_PUSH_ENABLED, s3);
        pushEnabled = s3;
    }
    //-- check if polling is enabled
    
    if(reg.cs.getPolling() == "0")
    {   
        checkPolling.SetCheck(BST_UNCHECKED);
        lstPolling.EnableWindow(FALSE);
    }
    else
    {   
        checkPolling.SetCheck(BST_CHECKED);
        lstPolling.EnableWindow(TRUE);
    }

    source = TEXT("");
    advanced = 0;
    
    lstPolling.SetCurSel(getPollingPosition(reg.cs.getPolling())); // 30 minutes set by default
    lstPolling.UpdateWindow();
    checkMail.SetFocus();

    
    //lstPolling.SetCurSel(1);
    //lstPolling.UpdateData();
    
    //int nnn = lstPolling.GetCount();
    return FALSE;
}

void CSyncSettings::OnSetfocusSyncContacts()
{
  if(checkContacts.GetCheck() == BST_CHECKED) 
  {
      EnableAdvancedButton(true);
      source=TEXT("contacts");
  }      
  else
  {
      EnableAdvancedButton(false);
  }
}

void CSyncSettings::OnBnClickedSyncContacts()
{
//#if (_WIN32_WCE < 0x500)
  #if defined(WIN32_PLATFORM_PSPC)
    if(checkContacts.GetCheck() == BST_UNCHECKED) 
        butContacts.EnableWindow(FALSE);
    else
        butContacts.EnableWindow(TRUE);
  #endif
//#else    
    if(checkContacts.GetCheck() == BST_CHECKED) 
    {
        source=TEXT("contacts");
        EnableAdvancedButton(true);
    }      
    else
    {
        EnableAdvancedButton(false);
    }
//#endif
}

void CSyncSettings::OnBnSetfocusSyncCalendar()
{
    if(checkCalendar.GetCheck() == BST_CHECKED) 
    {
        EnableAdvancedButton(true);
        source=TEXT("calendar");
    }      
    else
    {
        EnableAdvancedButton(false);
    }
}

void CSyncSettings::OnBnSetfocusSyncTasks()
{
    if(checkTasks.GetCheck() == BST_CHECKED) 
    {
        EnableAdvancedButton(true);
        source=TEXT("tasks");
    }      
    else
    {
        EnableAdvancedButton(false);
    }
}

void CSyncSettings::OnBnSetfocusSyncMail()
{
    if(checkMail.GetCheck() == BST_CHECKED) 
    {
        EnableAdvancedButton(true);
        source=TEXT("mail");
    }      
    else
    {
        EnableAdvancedButton(false);
    }
}

void CSyncSettings::OnBnSetfocusSyncBriefcase()
{
        if(checkBriefcase.GetCheck() == BST_CHECKED) 
        {
            source=TEXT("briefcase");
            EnableAdvancedButton(true);
        }      
        else
        {
            EnableAdvancedButton(false);
        }
}

void CSyncSettings::OnBnClickedSyncCalendar()
{
//#if (_WIN32_WCE < 0x500)
  #if defined(WIN32_PLATFORM_PSPC)
    if(checkCalendar.GetCheck() == BST_UNCHECKED) 
        butCalendar.EnableWindow(FALSE);
    else
        butCalendar.EnableWindow(TRUE);
  #endif
//#else    
    if(checkCalendar.GetCheck() == BST_CHECKED) 
    {
        source=TEXT("calendar");
        EnableAdvancedButton(true);
    }      
    else
    {
        EnableAdvancedButton(false);
    }
//#endif
}

void CSyncSettings::OnBnClickedSyncTasks()
{
//#if (_WIN32_WCE < 0x500)
  #if defined(WIN32_PLATFORM_PSPC)
    if(checkTasks.GetCheck() == BST_UNCHECKED) 
        butTasks.EnableWindow(FALSE);
    else
        butTasks.EnableWindow(TRUE);
 #endif
//#else    
    if(checkTasks.GetCheck() == BST_CHECKED) 
    {
        source=TEXT("tasks");
        EnableAdvancedButton(true);
    }      
    else
    {
        EnableAdvancedButton(false);
    }
//#endif
}

void CSyncSettings::OnBnClickedSyncMail()
{
//#if (_WIN32_WCE < 0x500)
  #if defined(WIN32_PLATFORM_PSPC)
    if(checkMail.GetCheck() == BST_UNCHECKED) 
        butMail.EnableWindow(FALSE);
    else
        butMail.EnableWindow(TRUE);
  #endif
//#else    
    if(checkMail.GetCheck() == BST_CHECKED) 
    {
        source=TEXT("mail");
        EnableAdvancedButton(true);
    }      
    else
    {
        EnableAdvancedButton(false);
    }
//#endif
}

void CSyncSettings::OnBnClickedSyncBriefcase()
{
//#if (_WIN32_WCE < 0x500)
  #if defined(WIN32_PLATFORM_PSPC)
    if(checkBriefcase.GetCheck() == BST_UNCHECKED) 
        butBriefcase.EnableWindow(FALSE);
    else
        butBriefcase.EnableWindow(TRUE);
  #endif
//#else    
    if(checkBriefcase.GetCheck() == BST_CHECKED) 
    {
        source=TEXT("briefcase");
        EnableAdvancedButton(true);
    }      
    else
    {
        EnableAdvancedButton(false);
    }
//#endif
}


void CSyncSettings::showAdvanced()
{
    if(source == "contacts")
    {
       #ifdef WIN32_PLATFORM_WFSP
         //dlgCommandBarAdvanced.Show(false);
       #endif

        CContactSettings wndContSett;
        INT_PTR result = wndContSett.DoModal();
        if(result == IDOK)
            advanced |= ADVANCED_CONTACTS;

       #ifdef WIN32_PLATFORM_WFSP
         //dlgCommandBarAdvanced.Show(true);
       #endif
       checkContacts.SetFocus();
    };

    if(source == "calendar")
    {
    #ifdef WIN32_PLATFORM_WFSP
        //dlgCommandBarAdvanced.Show(false);
    #endif

        CCalendarSettings wndSett;
        INT_PTR result = wndSett.DoModal();
        if(result == IDOK)
            advanced |= ADVANCED_CALENDAR;

    #ifdef WIN32_PLATFORM_WFSP
        dlgCommandBarAdvanced.Show(true);
    #endif
    checkCalendar.SetFocus();
    }

    if(source == "tasks")
    {
    #ifdef WIN32_PLATFORM_WFSP
        //dlgCommandBarAdvanced.Show(false);
    #endif

        CTaskSettings wndSett;
        INT_PTR result = wndSett.DoModal();
        if(result == IDOK)
            advanced |= ADVANCED_TASKS;

    #ifdef WIN32_PLATFORM_WFSP
        dlgCommandBarAdvanced.Show(true);
    #endif
    checkTasks.SetFocus();
    }

    if(source == "mail")
    {
    #ifdef WIN32_PLATFORM_WFSP
        //dlgCommandBarAdvanced.Show(false);
    #endif

        CMailSettings wndSett;
        INT_PTR result = wndSett.DoModal();
        if(result == IDOK)
            advanced |= ADVANCED_MAIL;

    #ifdef WIN32_PLATFORM_WFSP
        dlgCommandBarAdvanced.Show(true);
    #endif
    checkMail.SetFocus();
    }

    if(source == "briefcase")
    {
    #ifdef WIN32_PLATFORM_WFSP
        //dlgCommandBarAdvanced.Show(false);
    #endif

        CBriefcaseSettings wndSett;
        INT_PTR result = wndSett.DoModal();
        if(result == IDOK)
            advanced |= ADVANCED_BRIEFCASE;

    #ifdef WIN32_PLATFORM_WFSP
        dlgCommandBarAdvanced. Show(true);
    #endif
    checkBriefcase.SetFocus();
    }

 #if defined(WIN32_PLATFORM_PSPC)
    if(source == "note")
    {
    #ifdef WIN32_PLATFORM_WFSP
        //dlgCommandBarAdvanced.Show(false);
    #endif

        CNotesSettings wndSett;
        INT_PTR result = wndSett.DoModal();
        if(result == IDOK)
            advanced |= ADVANCED_NOTES;

    #ifdef WIN32_PLATFORM_WFSP
        dlgCommandBarAdvanced. Show(true);
    #endif
        checkNotes.SetFocus();
    }
 #endif
}


void CSyncSettings::OnOK()
{
    SyncRegSettings regsettings("all",false);

    if( (checkContacts.GetCheck() == BST_UNCHECKED))
    {
        //-- save none
        regsettings.cs.setConfigSourcesParameter("contact", "sync","none");
    }
    else
    {
        if( ( ~advanced | ADVANCED_CONTACTS) && 
            (!strcmp(regsettings.cs.getConfigSourcesParameter("contact", "sync"),"none")) )
        {
            //-- save 2way
            regsettings.cs.setConfigSourcesParameter("contact", "sync","two-way");
        }
    }
    
    if( (checkCalendar.GetCheck() == BST_UNCHECKED))
    {
        //-- save none
        regsettings.cs.setConfigSourcesParameter("calendar", "sync","none");
    }
    else
    {
         if( (! (advanced & ADVANCED_CALENDAR)) &&
             (!strcmp(regsettings.cs.getConfigSourcesParameter("calendar", "sync"),"none")) )
         {
             //-- save 2way
             regsettings.cs.setConfigSourcesParameter("calendar", "sync","two-way");
         }
    }

    if((checkTasks.GetCheck() == BST_UNCHECKED))
    {
        //-- save none
        regsettings.cs.setConfigSourcesParameter("task", "sync","none");
    }
    else
    {
        if( (! (advanced & ADVANCED_TASKS)) &&
            (!strcmp(regsettings.cs.getConfigSourcesParameter("task", "sync"),"none")) )
        {
            //-- save 2way
            regsettings.cs.setConfigSourcesParameter("task", "sync","two-way");
        }
    }
    
    if( (checkMail.GetCheck() == BST_UNCHECKED || !doesFunambolAccountExist()))
    {
        //-- save none
        regsettings.cs.setConfigSourcesParameter("mail", "sync","none");
    }
    else
    {
        if( (! (advanced & ADVANCED_MAIL)) &&
            (!strcmp(regsettings.cs.getConfigSourcesParameter("mail", "sync"),"none")) )
        {
            //-- save 2way
            regsettings.cs.setConfigSourcesParameter("mail", "sync","two-way");
        }
    }
    
    if( (checkBriefcase.GetCheck() == BST_UNCHECKED))
    {
        //-- save none
        regsettings.cs.setConfigSourcesParameter("briefcase", "sync","none");
    }
    else
    {
        if( (! (advanced & ADVANCED_BRIEFCASE)) &&
            (!strcmp(regsettings.cs.getConfigSourcesParameter("briefcase", "sync"),"none")) )
        {
            //-- save 2way
            regsettings.cs.setConfigSourcesParameter("briefcase", "sync","two-way");
        }
    }
  #if defined(WIN32_PLATFORM_PSPC)
    if( (checkNotes.GetCheck() == BST_UNCHECKED))
    {
        //-- save none
        regsettings.cs.setConfigSourcesParameter("note", "sync","none");
    }
    else
    {
        if( (! (advanced & ADVANCED_NOTES)) &&
            (!strcmp(regsettings.cs.getConfigSourcesParameter("note", "sync"),"none")) )
        {
            //-- save 2way
            regsettings.cs.setConfigSourcesParameter("note", "sync","two-way");
        }
    }
  #endif

    if(!checkStartSync()){
        regsettings.writeToRegistry("all", false);
    }
    

    //-- save encryption to registry
    CommunicationRegSettings reg;
    reg.readFromRegistry();
    
     //------ save polling
    SyncRegSettings regmail("mail");
    SyncRegSettings regcalendar("calendar");
    SyncRegSettings regcontacts("contact");
    SyncRegSettings regtasks("task");
    SyncRegSettings regbriefcase("briefcase");
    SyncRegSettings regnotes("note");

    if(checkEncryption.GetCheck() == BST_CHECKED) {
        regmail.cs.mailssconfig.setEncryption("des");
        regcalendar.cs.ssconfig.setEncryption("des");
        regcontacts.cs.ssconfig.setEncryption("des");
        regtasks.cs.ssconfig.setEncryption("des");
        regbriefcase.cs.ssconfig.setEncryption("des");
        regnotes.cs.ssconfig.setEncryption("des");
    } else {
        reg.cs.ssconfig.setEncryption("0");
        regmail.cs.mailssconfig.setEncryption("0");
        regcalendar.cs.ssconfig.setEncryption("0");
        regcontacts.cs.ssconfig.setEncryption("0");
        regtasks.cs.ssconfig.setEncryption("0");
        regbriefcase.cs.ssconfig.setEncryption("0");
        regnotes.cs.ssconfig.setEncryption("0");
    }
    
   
    if(checkPolling.GetCheck() == BST_CHECKED)
    {
        //char minutes[8][5] = {"5","10","15","30","60","120","240","1440"};
        //char minutes[8][5] = {"1","10","15","30","60","120","240","1440"};
        reg.cs.setPolling(CString(minutes[lstPolling.GetCurSel()]));
        //-- set the schedule value for every checked source
        
        regmail.cs.mailssconfig.setSchedule(atoi(minutes[lstPolling.GetCurSel()]));
        regcalendar.cs.setSchedule(CString(minutes[lstPolling.GetCurSel()]));
        regcontacts.cs.setSchedule(CString(minutes[lstPolling.GetCurSel()]));
        regtasks.cs.setSchedule(CString(minutes[lstPolling.GetCurSel()]));
        regbriefcase.cs.setSchedule(CString(minutes[lstPolling.GetCurSel()]));
        regnotes.cs.setSchedule(CString(minutes[lstPolling.GetCurSel()]));
    }
    else
    {
        reg.cs.setPolling(CString("0"));
        regmail.cs.mailssconfig.setSchedule(0);
        regcalendar.cs.setSchedule(CString("0"));
        regcontacts.cs.setSchedule(CString("0"));
        regtasks.cs.setSchedule(CString("0"));
        regbriefcase.cs.setSchedule(CString("0"));
        regnotes.cs.setSchedule(CString("0"));
    }

    if(!checkStartSync()){
        regmail.writeToRegistry("mail", false);   
        regcalendar.writeToRegistry("calendar", false);
        regcontacts.writeToRegistry("contact", false);
        regtasks.writeToRegistry("task", false);
        regbriefcase.writeToRegistry("briefcase", false);
        regnotes.writeToRegistry("note", false);

        reg.writeToRegistry();
    
        if(checkPolling.GetCheck() == BST_CHECKED)
            startProgram(_T("startsync.exe"), _T("poll"));
    };

    CDialog::OnOK();
}
void CSyncSettings::OnBnClickedSyncPolling()
{
    if(checkPolling.GetCheck() == BST_UNCHECKED)
    {
        lstPolling.EnableWindow(FALSE);
    }
    else
        lstPolling.EnableWindow(TRUE);
}

void CSyncSettings::EnableAdvancedButton(bool bEnable)
{
    #if ( (_WIN32_WCE < 0x500) && defined(WIN32_PLATFORM_PSPC) )
        return;
    #endif

    HWND hwndMB = SHFindMenuBar (this->GetSafeHwnd());
    TBBUTTONINFO tbi;
    if (!hwndMB) 
        return;

    memset (&tbi, 0, sizeof (tbi));
    tbi.cbSize = sizeof (tbi);
    tbi.dwMask = TBIF_STATE;
    ::SendMessage (hwndMB, TB_GETBUTTONINFO, IDADVANCED, (LPARAM)&tbi);

    if(bEnable)
        tbi.fsState = TBSTATE_ENABLED;
    else
        tbi.fsState &= ~TBSTATE_ENABLED;
    
    ::SendMessage (hwndMB, TB_SETBUTTONINFO, IDADVANCED, (LPARAM)&tbi);   
}

void CSyncSettings::OnBnSetfocusSyncPolling()
{
    EnableAdvancedButton(false);
}

void CSyncSettings::OnLbnSetfocusSchedulerMinutes()
{
    EnableAdvancedButton(false);
}

void CSyncSettings::OnBnSetfocusEncryption()
{
    EnableAdvancedButton(false);
}


#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CSyncSettings::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
    int resId;
    switch(DRA::GetDisplayMode())
    {
    case DRA::Landscape:
        resId = IDD_UI_SYNC_WIDE; break;
    case DRA::Portrait:
        resId = IDD_UI_SYNC; break;
    case DRA::Square:
        resId = IDD_UI_SYNC_SQUARE; break;
    default:
        resId = IDD_UI_SYNC; break;
    };

    DRA::RelayoutDialog( AfxGetInstanceHandle(), this->m_hWnd, MAKEINTRESOURCE(resId));
    SetDlgItemText(IDC_SYNC_PUSH_ENABLED, pushEnabled);
}
#endif

#if defined(WIN32_PLATFORM_PSPC)
//----- Pocket PC

void CSyncSettings::OnClickedSyncButtonMail()
{
    source = "mail";
    showAdvanced();
}

void CSyncSettings::OnClickedSyncButtonCalendar()
{
    source = "calendar";
    showAdvanced();
}

void CSyncSettings::OnClickedSyncButtonContacts()
{
    source = "contacts";
    showAdvanced();
}

void CSyncSettings::OnClickedSyncButtonTasks()
{
    source = "tasks";
    showAdvanced();
}

void CSyncSettings::OnClickedSyncButtonBriefcase()
{
    source = "briefcase";
    showAdvanced();
}

void CSyncSettings::OnBnClickedSyncNotes()
{
    if(checkNotes.GetCheck() == BST_UNCHECKED) 
        butNotes.EnableWindow(FALSE);
    else
        butNotes.EnableWindow(TRUE);
    
    if(checkNotes.GetCheck() == BST_CHECKED) 
    {
        source=TEXT("note");
        EnableAdvancedButton(true);
    }      
    else
    {
        EnableAdvancedButton(false);
    }
}


void CSyncSettings::OnClickedSyncButtonNotes()
{
    source = "note";
    showAdvanced();
}

//---- end Pocket PC part
#endif