/*
* Copyright (C) 2003-2006 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#pragma once
#include "stdafx.h"


#include <list>
using namespace std;

#if defined(WIN32_PLATFORM_PSPC)
//  defines and functions used by Pocket PC folder view tree control
#include <aygshell.h>

//Menu Bar Height
#define MENU_HEIGHT 26

#define SHGetMenu(hWndMB)  (HMENU)SendMessage((hWndMB), SHCMBM_GETMENU, (WPARAM)0, (LPARAM)0);
#define SHGetSubMenu(hWndMB,ID_MENU) (HMENU)SendMessage((hWndMB), SHCMBM_GETSUBMENU, (WPARAM)0, (LPARAM)ID_MENU);
#define SHSetSubMenu(hWndMB,ID_MENU) (HMENU)SendMessage((hWndMB), SHCMBM_SETSUBMENU, (WPARAM)0, (LPARAM)ID_MENU);

//Alternate definition
#define SHMenuBar_GetMenu(hWndMB,ID_MENU) (HMENU)SendMessage((hWndMB), SHCMBM_GETSUBMENU, (WPARAM)0, (LPARAM)ID_MENU);

typedef enum tagIMAGES { IMAGE_OPEN, IMAGE_CLOSED, IMAGE_EXE, IMAGE_TREE, IMAGE_DOCUMENT} IMAGES;

extern HINSTANCE g_hInstance;                                   
extern HWND hwndCB;
extern HIMAGELIST himl;			// handle of the image list

BOOL InitTreeViewImageLists(HWND);
BOOL InitTreeViewItems(HWND);
HTREEITEM AddItemToTree(HWND, LPTSTR, HTREEITEM, BOOL);
BOOL GetDirectoryContents(HWND hwndTV, LPTSTR pszDirectory, HTREEITEM htiParent);
BOOL BuildDirectory(HWND, TV_ITEM, LPTSTR);
BOOL GetDrives(HWND);

#define IDC_TREEVIEW	101
#define CX_BITMAP		 16
#define CY_BITMAP		 15
#define NUM_BITMAPS		  3

#endif


#if defined(WIN32_PLATFORM_WFSP)
    // Smartphone platform
    void AddItemToList(CListBox* , CString);
    BOOL GetDirectoryContents( CListBox* list1, LPTSTR pszDirectory);
    BOOL BuildDirectory(list<CString> path, CString& outString);
    BOOL InitListViewItems(CListBox* list1);
#endif