/*
* Copyright (C) 2003-2006 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#pragma once


// CSyncSettings dialog
#include "ui.h" 

class CSyncSettings : public CDialog
{
	DECLARE_DYNAMIC(CSyncSettings)

public:
	CSyncSettings(CWnd* pParent = NULL);   // standard constructor
	virtual ~CSyncSettings();

// Dialog Data
	enum { IDD = IDD_UI_SYNC };

protected:
    #if defined(WIN32_PLATFORM_PSPC)
        SHMENUBARINFO dlgCommandBar; 
        CComboBox lstPolling;
    #endif

    #if defined(WIN32_PLATFORM_WFSP)
        CCommandBar dlgCommandBarAdvanced;
        CListBox lstPolling;
        CSpinButtonCtrl spinPolling;
    #endif

    CButton checkMail;
    CButton checkCalendar;
    CButton checkContacts;
    CButton checkTasks;
    CButton checkBriefcase;
 
    CButton checkEncryption;
    CButton checkPolling;
    #if defined(WIN32_PLATFORM_PSPC) 
        CButton checkNotes;
        CButton butNotes;
        CButton butMail;
        CButton butCalendar;
        CButton butContacts;
        CButton butTasks;
        CButton butBriefcase;
    #endif

    CString source;
    CString pushEnabled;
    int advanced;

    void EnableAdvancedButton(bool bEnable);
    virtual BOOL OnInitDialog();
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    #if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
        afx_msg void OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/);
    #endif

	DECLARE_MESSAGE_MAP()
public:
    afx_msg void OnSetfocusSyncContacts();
    afx_msg void OnBnClickedSyncContacts();
    afx_msg void OnBnSetfocusSyncCalendar();
    afx_msg void OnSetFocus( CWnd* pOldWnd  );
    afx_msg void showAdvanced();
    afx_msg void OnBnSetfocusSyncTasks();
    afx_msg void OnBnSetfocusSyncMail();
    afx_msg void OnBnSetfocusSyncBriefcase();
    afx_msg void OnBnClickedSyncCalendar();
    afx_msg void OnBnClickedSyncTasks();
    afx_msg void OnBnClickedSyncMail();
    afx_msg void OnBnClickedSyncBriefcase();
    afx_msg void OnOK();
public:
    afx_msg void OnBnClickedSyncPolling();
public:
    afx_msg void OnBnSetfocusSyncPolling();
public:
    afx_msg void OnLbnSetfocusSchedulerMinutes();
public:
    afx_msg void OnBnSetfocusEncryption();
public:
    afx_msg void OnClickedSyncButtonMail();
public:
    afx_msg void OnClickedSyncButtonCalendar();
public:
    afx_msg void OnClickedSyncButtonContacts();
public:
    afx_msg void OnClickedSyncButtonTasks();
public:
    afx_msg void OnClickedSyncButtonBriefcase();
public:
    afx_msg void OnBnClickedSyncNotes();
public:
    afx_msg void OnClickedSyncButtonNotes();
};
