/*
* Copyright (C) 2003-2006 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// uiDlg.h : header file
//


#pragma once
#include "afxwin.h"

#if defined(WIN32_PLATFORM_PSPC)
    #include "aygshell.h" // shmenubarinfo
#endif


//-- my custom messages
//#define ID_TEMP1 (WM_APP+1)
#define ID_MYMSG_UPDATE_PROGBAR (WM_APP+2)
#define ID_MYMSG_STARTSYNC_ENDED (WM_APP+3)
#define ID_MYMSG_STARTING_SYNC (WM_APP+4)
#define ID_MYMSG_SOURCES_NUMBER (WM_APP+5)
#define ID_MYMSG_STARTING_SOURCE (WM_APP+6)
#define ID_MYMSG_ITEM_SYNCED_FROM_SERVER (WM_APP+7)
#define ID_MYMSG_TOTAL_ITEMS (WM_APP+8)
#define ID_MYMSG_ITEM_SYNCED_FROM_CLIENT (WM_APP+9)


// CuiDlg dialog
class CuiDlg : public CDialog
{
// Construction
public:
	CuiDlg(CWnd* pParent = NULL);	// standard constructor

	void OnMenuComm();

// Dialog Data
	enum { IDD = IDD_UI_DIALOG };

protected:
    #if defined(WIN32_PLATFORM_PSPC)
       SHMENUBARINFO dlgCommandBar; 
       void CreateMenuBar(const int id);
    #endif
    
    #ifdef WIN32_PLATFORM_WFSP
        CCommandBar dlgCommandBar;
        CCommandBar dlgCmdBarStop;
        CCommandBar dlgCmdBarMenu;

        CStatic imageLogo;  //-- Funambol logo bitmap
        CBitmap bmpBitmap; //-- bitmap holding the image
    #endif 

	CProgressCtrl progressBar;
	
	bool bSyncStarted;
    int currentSource;
    int totalSources;
    int totalItems;
    bool resetCurrentItem;
    int lastItem;
    int currentItem;
    int lastSource;
    bool updatedPbar; 
    bool lastSourceIsFromClient;
    bool syncStartedFromUI;

    bool isInSettings; // if a settings child window is opened


protected:
    virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
    HICON m_hIcon;
    virtual BOOL OnInitDialog();
    void StepProgBar(int from);

    #if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	    afx_msg void OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/);
    #endif
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnMenuLoglevel();
	afx_msg void OnSync();
	afx_msg void OnMenuExit();
	afx_msg void OnMenuRecover();
	afx_msg LRESULT OnMsgUpdateProgressBar(WPARAM , LPARAM);
//	afx_msg void OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu);
	
    //-- startsync exit code as lParam
    afx_msg LRESULT OnStartsyncEnded(WPARAM , LPARAM); 

    afx_msg LRESULT OnStartingSync(WPARAM , LPARAM);
    afx_msg LRESULT OnMsgSourcesNumber(WPARAM , LPARAM);
    afx_msg LRESULT OnStartingSource(WPARAM , LPARAM);
    void OnMsgItemSynced(WPARAM , LPARAM, bool);
    afx_msg LRESULT OnMsgTotalItems(WPARAM , LPARAM);

    afx_msg LRESULT OnMsgItemSyncedFromServer(WPARAM , LPARAM);
    afx_msg LRESULT OnMsgItemSyncedFromClient(WPARAM , LPARAM);

    afx_msg void OnMenuAbout();
    afx_msg void OnMenuStop();
    afx_msg void OnMenuPush();

    afx_msg void OnEnterMenuLoop(BOOL bIsTrackPopupMenu);
    afx_msg void OnExitMenuLoop(BOOL bIsTrackPopupMenu );

    afx_msg void OnInitMenuPopup(CMenu* pPopupMenu,UINT nIndex,BOOL bSysMenu);
    afx_msg void OnUnInitMenuPopup(CMenu* pPopupMenu,UINT nIndex,BOOL bSysMenu);

    afx_msg void OnMenuSync();

    afx_msg void OnOK();
    afx_msg void OnCancel();
};
