/*
* Copyright (C) 2003-2006 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef INCL_SYNC_RESULTS
#define INCL_SYNC_RESULTS
	
#include "base/winmobileadapter.h"

#include "spds/constants.h"

#define SYNCRESULTS_FILENAME "syncresults.txt"
#define SYNCRESULTS_SYNC_CONTACTS 1
#define SYNCRESULTS_SYNC_CALENDAR 2
#define SYNCRESULTS_SYNC_TASKS 4
#define SYNCRESULTS_SYNC_FILES 8 
#define SYNCRESULTS_SYNC_MAIL  16
#define SYNCRESULTS_SYNC_NOTES  32

#define SYNCRESULTS_CONTACTS_SLOW 1
#define SYNCRESULTS_CALENDAR_SLOW 2
#define SYNCRESULTS_TASKS_SLOW 4
#define SYNCRESULTS_MAIL_SLOW 8
#define SYNCRESULTS_BRIEFCASE_SLOW 16
#define SYNCRESULTS_NOTES_SLOW  32

#define CURRENT_SOURCE_MAIL 1
#define CURRENT_SOURCE_CALENDAR 2
#define CURRENT_SOURCE_CONTACT 3
#define CURRENT_SOURCE_TASK 4
#define CURRENT_SOURCE_BRIEFCASE 5
#define CURRENT_SOURCE_NOTES 6

#define SYNCRESULTS_MAIL_SYNC 1
#define SYNCRESULTS_MAIL_2SYNC 2



extern char logmsg[];

class SyncResults
{
public:
    int itemNumber;
    int totalItems;
    int flagTotalItems; 
    int totalSources;
    int syncTypes;
    int flagMail;
private:
    int currentSource;      //which source is currently syncing
    
    char* syncTime;
    int nrCalendars[6];
    int nrContacts[6];
    int nrTasks[6];
    int nrFiles[6];
    int nrNotes[6];
    int nrMails[6];
    int syncedSources; // bitmask
	
public:
	void printMessage( const char* msg , ...);//, va_list argList);
    SyncResults(BOOL reset = FALSE, char* path = NULL, char* name = NULL);
    ~SyncResults();

    void reset(const char* title = NULL);	
	void setLogPath(char* configLogPath);
    void setLogName(char* configLogName);

    void incMails(int index);
    void updateMails(int values[6]);
    void writeMailSyncResults();

    void updatePim(const char* item, int values[6],bool fromClient);
    void writePimSyncResults();
    void setCurrentSource(int value)  {currentSource = value;}
    int getCurrentSource() {return currentSource; }
};

extern SyncResults SyncResultsLogger;


#endif